// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from camera_aravis2_msgs:srv/SetBooleanFeatureValue.idl
// generated code does not contain a copyright notice

#ifndef CAMERA_ARAVIS2_MSGS__SRV__DETAIL__SET_BOOLEAN_FEATURE_VALUE__STRUCT_HPP_
#define CAMERA_ARAVIS2_MSGS__SRV__DETAIL__SET_BOOLEAN_FEATURE_VALUE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__camera_aravis2_msgs__srv__SetBooleanFeatureValue_Request __attribute__((deprecated))
#else
# define DEPRECATED__camera_aravis2_msgs__srv__SetBooleanFeatureValue_Request __declspec(deprecated)
#endif

namespace camera_aravis2_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetBooleanFeatureValue_Request_
{
  using Type = SetBooleanFeatureValue_Request_<ContainerAllocator>;

  explicit SetBooleanFeatureValue_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->feature = "";
      this->value = false;
    }
  }

  explicit SetBooleanFeatureValue_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : feature(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->feature = "";
      this->value = false;
    }
  }

  // field types and members
  using _feature_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _feature_type feature;
  using _value_type =
    bool;
  _value_type value;

  // setters for named parameter idiom
  Type & set__feature(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->feature = _arg;
    return *this;
  }
  Type & set__value(
    const bool & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    camera_aravis2_msgs::srv::SetBooleanFeatureValue_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const camera_aravis2_msgs::srv::SetBooleanFeatureValue_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      camera_aravis2_msgs::srv::SetBooleanFeatureValue_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      camera_aravis2_msgs::srv::SetBooleanFeatureValue_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__camera_aravis2_msgs__srv__SetBooleanFeatureValue_Request
    std::shared_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__camera_aravis2_msgs__srv__SetBooleanFeatureValue_Request
    std::shared_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetBooleanFeatureValue_Request_ & other) const
  {
    if (this->feature != other.feature) {
      return false;
    }
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetBooleanFeatureValue_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetBooleanFeatureValue_Request_

// alias to use template instance with default allocator
using SetBooleanFeatureValue_Request =
  camera_aravis2_msgs::srv::SetBooleanFeatureValue_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace camera_aravis2_msgs


#ifndef _WIN32
# define DEPRECATED__camera_aravis2_msgs__srv__SetBooleanFeatureValue_Response __attribute__((deprecated))
#else
# define DEPRECATED__camera_aravis2_msgs__srv__SetBooleanFeatureValue_Response __declspec(deprecated)
#endif

namespace camera_aravis2_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetBooleanFeatureValue_Response_
{
  using Type = SetBooleanFeatureValue_Response_<ContainerAllocator>;

  explicit SetBooleanFeatureValue_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ok = false;
    }
  }

  explicit SetBooleanFeatureValue_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ok = false;
    }
  }

  // field types and members
  using _ok_type =
    bool;
  _ok_type ok;

  // setters for named parameter idiom
  Type & set__ok(
    const bool & _arg)
  {
    this->ok = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    camera_aravis2_msgs::srv::SetBooleanFeatureValue_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const camera_aravis2_msgs::srv::SetBooleanFeatureValue_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      camera_aravis2_msgs::srv::SetBooleanFeatureValue_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      camera_aravis2_msgs::srv::SetBooleanFeatureValue_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__camera_aravis2_msgs__srv__SetBooleanFeatureValue_Response
    std::shared_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__camera_aravis2_msgs__srv__SetBooleanFeatureValue_Response
    std::shared_ptr<camera_aravis2_msgs::srv::SetBooleanFeatureValue_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetBooleanFeatureValue_Response_ & other) const
  {
    if (this->ok != other.ok) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetBooleanFeatureValue_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetBooleanFeatureValue_Response_

// alias to use template instance with default allocator
using SetBooleanFeatureValue_Response =
  camera_aravis2_msgs::srv::SetBooleanFeatureValue_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace camera_aravis2_msgs

namespace camera_aravis2_msgs
{

namespace srv
{

struct SetBooleanFeatureValue
{
  using Request = camera_aravis2_msgs::srv::SetBooleanFeatureValue_Request;
  using Response = camera_aravis2_msgs::srv::SetBooleanFeatureValue_Response;
};

}  // namespace srv

}  // namespace camera_aravis2_msgs

#endif  // CAMERA_ARAVIS2_MSGS__SRV__DETAIL__SET_BOOLEAN_FEATURE_VALUE__STRUCT_HPP_
