// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from camera_aravis2_msgs:srv/GetBooleanFeatureValue.idl
// generated code does not contain a copyright notice

#ifndef CAMERA_ARAVIS2_MSGS__SRV__DETAIL__GET_BOOLEAN_FEATURE_VALUE__TRAITS_HPP_
#define CAMERA_ARAVIS2_MSGS__SRV__DETAIL__GET_BOOLEAN_FEATURE_VALUE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "camera_aravis2_msgs/srv/detail/get_boolean_feature_value__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace camera_aravis2_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetBooleanFeatureValue_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: feature
  {
    out << "feature: ";
    rosidl_generator_traits::value_to_yaml(msg.feature, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetBooleanFeatureValue_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: feature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "feature: ";
    rosidl_generator_traits::value_to_yaml(msg.feature, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetBooleanFeatureValue_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace camera_aravis2_msgs

namespace rosidl_generator_traits
{

[[deprecated("use camera_aravis2_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const camera_aravis2_msgs::srv::GetBooleanFeatureValue_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  camera_aravis2_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use camera_aravis2_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const camera_aravis2_msgs::srv::GetBooleanFeatureValue_Request & msg)
{
  return camera_aravis2_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Request>()
{
  return "camera_aravis2_msgs::srv::GetBooleanFeatureValue_Request";
}

template<>
inline const char * name<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Request>()
{
  return "camera_aravis2_msgs/srv/GetBooleanFeatureValue_Request";
}

template<>
struct has_fixed_size<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace camera_aravis2_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetBooleanFeatureValue_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: response
  {
    out << "response: ";
    rosidl_generator_traits::value_to_yaml(msg.response, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetBooleanFeatureValue_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "response: ";
    rosidl_generator_traits::value_to_yaml(msg.response, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetBooleanFeatureValue_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace camera_aravis2_msgs

namespace rosidl_generator_traits
{

[[deprecated("use camera_aravis2_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const camera_aravis2_msgs::srv::GetBooleanFeatureValue_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  camera_aravis2_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use camera_aravis2_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const camera_aravis2_msgs::srv::GetBooleanFeatureValue_Response & msg)
{
  return camera_aravis2_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Response>()
{
  return "camera_aravis2_msgs::srv::GetBooleanFeatureValue_Response";
}

template<>
inline const char * name<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Response>()
{
  return "camera_aravis2_msgs/srv/GetBooleanFeatureValue_Response";
}

template<>
struct has_fixed_size<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<camera_aravis2_msgs::srv::GetBooleanFeatureValue>()
{
  return "camera_aravis2_msgs::srv::GetBooleanFeatureValue";
}

template<>
inline const char * name<camera_aravis2_msgs::srv::GetBooleanFeatureValue>()
{
  return "camera_aravis2_msgs/srv/GetBooleanFeatureValue";
}

template<>
struct has_fixed_size<camera_aravis2_msgs::srv::GetBooleanFeatureValue>
  : std::integral_constant<
    bool,
    has_fixed_size<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Request>::value &&
    has_fixed_size<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Response>::value
  >
{
};

template<>
struct has_bounded_size<camera_aravis2_msgs::srv::GetBooleanFeatureValue>
  : std::integral_constant<
    bool,
    has_bounded_size<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Request>::value &&
    has_bounded_size<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Response>::value
  >
{
};

template<>
struct is_service<camera_aravis2_msgs::srv::GetBooleanFeatureValue>
  : std::true_type
{
};

template<>
struct is_service_request<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Request>
  : std::true_type
{
};

template<>
struct is_service_response<camera_aravis2_msgs::srv::GetBooleanFeatureValue_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // CAMERA_ARAVIS2_MSGS__SRV__DETAIL__GET_BOOLEAN_FEATURE_VALUE__TRAITS_HPP_
